#!/bin/bash -e

# Set the problem name to generate correct file names
PROBLEMNAME="averagerank"

# Set this if you want to generate answers.
g++ -O2 ../../submissions/accepted/lukas.cc -o /tmp/a.out
#cp ../../submissions/accepted/solution.py /tmp/sol.py
SOLVER=/tmp/a.out
MAXN=300000
MAXD=300000
MAXP=1000000

rm -f *_generated.{in,ans}

generate() {
    ((COUNT++))
    printf -v padCount "%02d" $COUNT
    ./gendata.py -s $COUNT -n $1 -d $2 -p $3 -o $4 > ${padCount}_n$1_d$2_p$3_$4_generated.in
}

COUNT=10
generate 1 1 1 random
generate 5 6 10 random
generate 10 10 30 random
generate 31 29 177 random

COUNT=40
generate 310 290 1770 random
generate 1765 794 27702 harmonic
generate 1 $MAXD $MAXP random
generate $MAXN 1 $MAXP random
generate $MAXN $MAXD 1 random
generate 100000 10000 $MAXP random
generate $MAXN $MAXD $MAXP random
generate 100000 10000 $MAXP harmonic
generate $MAXN $MAXD $MAXP harmonic
generate $MAXN $MAXD $MAXP harmonic
generate $MAXN $(($MAXD / 100)) $MAXP harmonic
generate $(($MAXN / 10)) $MAXD $MAXP harmonic
generate 1000 1000 $MAXP random
generate 1000 1000 $(($MAXP / 10)) harmonic
generate $MAXN 10 $MAXP random
generate $MAXN $MAXD $MAXP exponential
generate $(($MAXN / 20)) $MAXD $MAXP exponential
generate $MAXN $MAXD $MAXP linear
generate $(($MAXN / 500)) $MAXD $MAXP linear
generate $MAXN $MAXD 0 random
generate $MAXN $MAXD $MAXP close_race
generate $(($MAXN / 100)) $MAXD $MAXP close_race

# generate solutions for all files
if [[ ! -z $SOLVER ]]
then
    for f in *_generated.in
    do
        echo "solving $f"
        $SOLVER < $f > ${f%???}.ans
    done
fi
