#!/bin/bash

set -euo pipefail

usage() {
  echo "  Options:"
  echo "     -r (rebuild): create new files for every input"
  exit 1
}

cleanup() {
  rm -f {sample,secret}/*.eps
}

rebuild=
while getopts 'r' flag; do
    case "${flag}" in
        r) rebuild=true ;;
        *) usage ;;
    esac;
done

trap cleanup EXIT

for f in {sample,secret}/*.in; do
    if [ -z "$rebuild" ] && [ -f ${f%.in}.png ]; then
        continue
    fi
    printf '%-32s' "$f..."
    cat $f ${f%.in}.ans \
      | timeout 10 asy -f png visualize.asy -o ${f%.in}.png \
      && echo -e '\e[32mdone\e[0m' \
      || echo -e '\e[31mtimed out\e[0m'
done
