#!/usr/bin/env python3
import sys, argparse, random
# Generate a single testcase for numerology

parser = argparse.ArgumentParser(description="Generator for Numerology.")
parser.add_argument('-o', metavar='O', type=str, default="random",
                    help='Options for generation')
parser.add_argument('-n', metavar='N', type=int, required=True,
                    help='number of people')
parser.add_argument('-t', metavar='T', type=int, default=None,
                    help='total number of (person, number) pairs')
parser.add_argument('-d', metavar='D', type=int, default=None,
                    help='number of distinct numbers')
parser.add_argument('-s', metavar='S', type=int, default=None,
                    help='seed for generation (optional)')

args = parser.parse_args()
random.seed(args.s)

options = args.o
n = args.n
t = args.t
d = args.d

if "random" in options:
    numbers = random.sample(range(1,10**9), d)
    D = [[] for i in range(n)] # numbers that describe person i

    for i in range(0, n):
        r = random.randint(0,d-1)
        D[i].append(r)

    extra = random.sample(range(0, n*(d-1)), t-n)

    for h in extra:
        person = h%n
        num_index = h//n
        if num_index >= D[person][0]:
            num_index += 1
        D[person].append(num_index)

    print(n)
    for i in range(0, n):
        print(len(D[i]), end = " ")
        D2 = [numbers[j] for j in D[i]]
        print(*D2)
elif "line" in options:
    # A line graph
    numbers = random.sample(range(1,10**9), n-1)
    D = [[] for i in range(n)]
    for i in range(0,n):
        if i > 0:
            D[i].append(numbers[i-1])
        if i < n-1:
            D[i].append(numbers[i])
    print(n)
    for i in range(0,n):
        print(len(D[i]), end = " ")
        print(*D[i])

    
